from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, String, Boolean

Joingenes_V0_1_0 = CommandToolBuilder(tool="joingenes", base_command=["joingenes"], inputs=[ToolInput(tag="in_gene_sets", input_type=File(optional=True), prefix="--genesets", doc=InputDocumentation(doc=",file2,...      -g file1,file2,...      where 'file1,file2,...,filen' have to be data files with genesets in GTF format.")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="where 'ofile' is the name for an output file (GTF).")), ToolInput(tag="in_priorities", input_type=Int(optional=True), prefix="--priorities", doc=InputDocumentation(doc=",pr2,...        -p pr1,pr2,...          where 'pr1,pr2,...,prn' have to be positiv integers (different from 0).")), ToolInput(tag="in_input_file", input_type=File(optional=True), prefix="--inputfile", doc=InputDocumentation(doc="where 'file' is the path of a file containing paths to GTF files and corresponding priorities in a tab-separated list (2 columns). Use this option instead of -g and -p\nHave to be as many as filenames are added.\nBigger numbers means a higher priority.\nIf no priorities are added, the program will set all priorties to 1.\nThis option is only useful, if there is more than one geneset.\nIf there is a conflict between two transcripts, so that they can not be picked in the same genestructure, joingenes decides for the one with the highest priority.")), ToolInput(tag="in_error_distance", input_type=Int(optional=True), prefix="--errordistance", doc=InputDocumentation(doc="where 'x' is a non-negative integer\nIf a prediction is <=x bases next to a prediction range border, the program supposes, that there could be a mistake.\nDefault is 1000.\nTo disable the function, set errordistance to a negative number (e.g. -1).")), ToolInput(tag="in_gene_model", input_type=String(optional=True), prefix="--genemodel", doc=InputDocumentation(doc="where 'x' is a genemodel from the set {eukaryote, bacterium}.\nDefault is eukaryotic.")), ToolInput(tag="in_alternatives", input_type=Boolean(optional=True), prefix="--alternatives", doc=InputDocumentation(doc="is a flag\nIf this flag is set, the program joines different genes, if the transcripts of the genes are alternative variants.")), ToolInput(tag="in_suppress", input_type=File(optional=True), prefix="--suppress", doc=InputDocumentation(doc=",pr2,..           -s pr1,pr2,...          where 'pr1,pr2,...,prm' have to be positiv integers (different from 0).\nDefault is none.\nif the core of a joined/non-joined transcript has one of these priorities it will not occur in the output file.")), ToolInput(tag="in_stop_in_coding", input_type=Boolean(optional=True), prefix="--stopincoding", doc=InputDocumentation(doc="is a flag\nIf this flag is set, the program joines the stop_codons to the CDS.")), ToolInput(tag="in_no_join", input_type=Boolean(optional=True), prefix="--nojoin", doc=InputDocumentation(doc="is a flag (to disable joining).\nIf this flag is set, the program will not join/merge/shuffle;\nit will only decide between the unchanged input transcipts and output them.")), ToolInput(tag="in_no_selection", input_type=Boolean(optional=True), prefix="--noselection", doc=InputDocumentation(doc="is a flag (to disable selection).\nIf this flag is set, the program will NOT select at the end between 'contradictory' transcripts.\n'contradictory' is self defined with respect to known biological terms.\nThe selection works with a self defined scoring function.")), ToolInput(tag="in_only_compare", input_type=Boolean(optional=True), prefix="--onlycompare", doc=InputDocumentation(doc="is a flag.\nIf this flag is set, it disables the normal function of the program and\nactivates a compare and separate mode to separate equal transcripts from non equal ones."))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="where 'ofile' is the name for an output file (GTF).")), ToolOutput(tag="out_suppress", output_type=File(optional=True), selector=InputSelector(input_to_select="in_suppress", type_hint=File()), doc=OutputDocumentation(doc=",pr2,..           -s pr1,pr2,...          where 'pr1,pr2,...,prm' have to be positiv integers (different from 0).\nDefault is none.\nif the core of a joined/non-joined transcript has one of these priorities it will not occur in the output file."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Joingenes_V0_1_0().translate("wdl", allow_empty_container=True)

